package com.zt.plat.module.qms.business.config.service;

import cn.hutool.core.collection.CollUtil;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import org.springframework.stereotype.Service;
import jakarta.annotation.Resource;
import org.springframework.validation.annotation.Validated;

import java.util.*;
import com.zt.plat.module.qms.business.config.controller.vo.*;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodDO;
import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.common.util.object.BeanUtils;

import com.zt.plat.module.qms.business.config.dal.mapper.ConfigAssayMethodMapper;

import static com.zt.plat.framework.common.exception.util.ServiceExceptionUtil.exception;
import static com.zt.plat.framework.common.util.collection.CollectionUtils.convertList;
import static com.zt.plat.module.qms.enums.ErrorCodeConstants.CONFIG_ASSAY_METHOD_NOT_EXISTS;

/**
 * 检测方法配置 Service 实现类
 *
 * @author 后台管理
 */
@Service
@Validated
public class ConfigAssayMethodServiceImpl implements ConfigAssayMethodService {

    @Resource
    private ConfigAssayMethodMapper configAssayMethodMapper;

    @Override
    public ConfigAssayMethodRespVO createConfigAssayMethod(ConfigAssayMethodSaveReqVO createReqVO) {
        // 插入
        ConfigAssayMethodDO configAssayMethod = BeanUtils.toBean(createReqVO, ConfigAssayMethodDO.class);
        configAssayMethodMapper.insert(configAssayMethod);
        // 返回
        return BeanUtils.toBean(configAssayMethod, ConfigAssayMethodRespVO.class);
    }

    @Override
    public void updateConfigAssayMethod(ConfigAssayMethodSaveReqVO updateReqVO) {
        // 校验存在
        validateConfigAssayMethodExists(updateReqVO.getId());
        // 更新
        ConfigAssayMethodDO updateObj = BeanUtils.toBean(updateReqVO, ConfigAssayMethodDO.class);
        configAssayMethodMapper.updateById(updateObj);
    }

    @Override
    public void deleteConfigAssayMethod(Long id) {
        // 校验存在
        validateConfigAssayMethodExists(id);
        // 删除
        configAssayMethodMapper.deleteById(id);
    }

    @Override
        public void deleteConfigAssayMethodListByIds(List<Long> ids) {
        // 校验存在
        validateConfigAssayMethodExists(ids);
        // 删除
        configAssayMethodMapper.deleteByIds(ids);
        }

    private void validateConfigAssayMethodExists(List<Long> ids) {
        List<ConfigAssayMethodDO> list = configAssayMethodMapper.selectByIds(ids);
        if (CollUtil.isEmpty(list) || list.size() != ids.size()) {
            throw exception(CONFIG_ASSAY_METHOD_NOT_EXISTS);
        }
    }

    private void validateConfigAssayMethodExists(Long id) {
        if (configAssayMethodMapper.selectById(id) == null) {
            throw exception(CONFIG_ASSAY_METHOD_NOT_EXISTS);
        }
    }

    @Override
    public ConfigAssayMethodDO getConfigAssayMethod(Long id) {
        return configAssayMethodMapper.selectById(id);
    }

	@Override
	public List<ConfigAssayMethodExtendRespVO> getConfigAssayMethodList(ConfigAssayMethodReqVO reqVO) {
		return BeanUtils.toBean(configAssayMethodMapper.selectList(reqVO), ConfigAssayMethodExtendRespVO.class);
	}

    @Override
    public PageResult<ConfigAssayMethodExtendRespVO> getConfigAssayMethodPage(ConfigAssayMethodPageReqVO pageReqVO) {
        return BeanUtils.toBean(configAssayMethodMapper.selectPage(pageReqVO), ConfigAssayMethodExtendRespVO.class);
    }

}